/*
 * lapack_clag2z.c
 *
 *This program is a C interface to clag2z.
 *
 * Written by Remi Delmas.
 *
 */

#include "../include/lapack_f77.h"
#include "../include/lapack_enum.h"
#include "../include/lapack_aux.h"

void lapack_clag2z(const int m, const int n, float * sa, const int ldsa, const double * a, const int lda, int * info )
{
#ifdef F77_INT
	F77_INT F77_m=m, F77_n=n, F77_ldsa=ldsa, F77_lda=lda;
	int i_local;
	F77_INT F77_info[1];
#else
	#define F77_m m
	#define F77_n n
	#define F77_ldsa ldsa
	#define F77_lda lda
	#define F77_info info
#endif

	f77_clag2z(&F77_m, &F77_n, sa, &F77_ldsa, a, &F77_lda, F77_info);

#ifdef F77_INT
	info[0]=(int) F77_info[0];
#endif

}
